﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{





    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Session["DataSource_Session"] = null;
            WebHierarchicalDataGrid1.AutoGenerateColumns = false;
        }

        object data = Session["DataSource_Session"];
        if (data != null)
        {
            if (data.GetType() == typeof(A[]))
            {

                WebHierarchicalDataGrid1.DataKeyFields = "uniqueID";

                WebHierarchicalDataGrid1.DataSource = (A[])data;

                WebHierarchicalDataGrid1.DataBind();

            }

            else if (data.GetType() == typeof(B[]))
            {

                WebHierarchicalDataGrid1.DataKeyFields = "uniqueID";

                WebHierarchicalDataGrid1.DataSource = (B[])data;

                WebHierarchicalDataGrid1.DataBind();

            }

        }
    }
    protected void Button_A_Click(object sender, EventArgs e)
    {

        WebHierarchicalDataGrid1.GridView.Columns.Clear();

        WebHierarchicalDataGrid1.GridView.ClearDataSource();



        BoundDataField dtf = new BoundDataField();

        dtf.Header.Text = "Unique ID";

        dtf.Key = "uniqueID";

        dtf.DataFieldName = "uniqueID";
        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf);


        BoundDataField dtf1 = new BoundDataField();

        dtf1.Header.Text = "Value A";

        dtf1.Key = "valueA";

        dtf1.DataFieldName = "valueA";





        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf1);

        BoundDataField dtf2 = new BoundDataField();

        dtf2.Header.Text = "Value A1";

        dtf2.Key = "valueA1";

        dtf2.DataFieldName = "valueA1";

        dtf2.Hidden = true;




        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf2);



        A[] valueList = new A[10];



        for (int i = 0; i < 10; i++)
        {

            A obj = new A();

            obj.uniqueID = i;

            obj.valueA = "Value A " + i.ToString();
            obj.valueA1 = "Value A1 " + i.ToString();



            valueList[i] = obj;

        }





        WebHierarchicalDataGrid1.GridView.DataKeyFields = "uniqueID";
        WebHierarchicalDataGrid1.DataSource = valueList;



        WebHierarchicalDataGrid1.DataBind();



        WebHierarchicalDataGrid1.RefreshBehaviors();



        Session["DataSource_Session"] = valueList;


    }
    protected void Button_B_Click(object sender, EventArgs e)
    {
        WebHierarchicalDataGrid1.GridView.ClearDataSource();
        WebHierarchicalDataGrid1.GridView.Columns.Clear();





        BoundDataField dtf = new BoundDataField();

        dtf.Header.Text = "Unique ID";

        dtf.Key = "uniqueID";

        dtf.DataFieldName = "uniqueID";
        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf);


        BoundDataField dtf1 = new BoundDataField();

        dtf1.Header.Text = "Value B";

        dtf1.Key = "valueB";

        dtf1.DataFieldName = "valueB";
        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf1);

        BoundDataField dtf2 = new BoundDataField();

        dtf2.Header.Text = "Value B1";

        dtf2.Key = "valueB1";

        dtf2.DataFieldName = "valueB1";
        dtf2.Hidden = true;
        WebHierarchicalDataGrid1.GridView.Columns.Add(dtf2);



        B[] valueList = new B[10];



        for (int i = 0; i < 10; i++)
        {

            B obj = new B();

            obj.uniqueID = i;

            obj.valueB = "Value B " + i.ToString();
            obj.valueB1 = "Value B1 " + i.ToString();



            valueList[i] = obj;

        }



        WebHierarchicalDataGrid1.DataKeyFields = "uniqueID";
        WebHierarchicalDataGrid1.DataSource = valueList;

        //  WebHierarchicalDataGrid1.DataBind();



        //  WebHierarchicalDataGrid1.GridView.DataKeyFields = WebHierarchicalDataGrid1.DataKeyFields;

        //  WebHierarchicalDataGrid1.GridView.DataSource = WebHierarchicalDataGrid1.DataSource;

        WebHierarchicalDataGrid1.DataBind();



        WebHierarchicalDataGrid1.RefreshBehaviors();



        Session["DataSource_Session"] = valueList;

    }
}